echo
echo MacOS Time Machine speed mode simple manager v0.8
echo TheUnF Networks, Inc - apple@theunf.net
echo

# Get value set to be used in boot time instead default debug.lowpri_throttle_enabled=1
# If boot time preferences file exists, get the speed mode set
if [ -f /Library/LaunchDaemons/nothrottle.plist ]; then
 export DefaultSpeed=`grep -q debug.lowpri_throttle_enabled /Library/LaunchDaemons/nothrottle.plist 2>/dev/null | cut -f 2 -d = | cut -f 1 -d \<`

# If file does NOT exist, work as Standard speed mode is set by default
else 
 DefaultSpeed=1
fi

if [ $(command -v csrutil|grep -c csrutil) -gt 0 ]; then
 export CheckSIP=`csrutil status 2>/dev/null|grep -ic enabled`
else
 export CheckSIP=0
fi
 
function CheckValue {

  if [ "$1" == "d" ]; then
   Speed=$DefaultSpeed
  else
   #[ ! -z "$CurrentSpeed" ] && export CurrentSpeed=`sysctl debug.lowpri_throttle_enabled | cut -f 2 -d \: | cut -f 2 -d \  `
   export CurrentSpeed=`sysctl debug.lowpri_throttle_enabled | cut -f 2 -d \: | cut -f 2 -d \  `
   Speed=$CurrentSpeed
  fi
  
  printf $Speed;

}

function CheckValueTXT {

  if [ "$1" == "d" ]; then
   Speed=$DefaultSpeed
  else
   #[ ! -z "$CurrentSpeed" ] && export CurrentSpeed=`sysctl debug.lowpri_throttle_enabled | cut -f 2 -d \: | cut -f 2 -d \  `
   export CurrentSpeed=`sysctl debug.lowpri_throttle_enabled | cut -f 2 -d \: | cut -f 2 -d \  `
   Speed=$CurrentSpeed
  fi
 
  if [ "$Speed" == "0" ]; then
   printf "High [0]"; 
  elif [ "$Speed" == "1" ];then
   printf "Standard [1]";
  else
   printf "Custom value [$Speed]";
  fi

}

# Processing command line parameters
if [ ! -z "$1" ]; then

 # With -d parameter, just print current definition
 if [[ "$1" == "-d" || "$1" == "-D" ]]; then
  printf "  Time Machine speed mode is configured to be defined at boot time as "
  CheckValueTXT d
  echo 

  printf "  and is currently running as "
  CheckValueTXT c
  echo

 # With -h parameter, print quick help  
 else
  printf "    -d/-D	Shows settings for Time Machine speed, current and at boot time\n"
  printf "    -h/-H	Presents this help\n\n"
  printf "  With no arguments, this script will change Standard or Custom settings to High, the Faster speed\n"
  printf "  and if High is set, set it back to Standard speed\n\n"

 fi

 if [ $CheckSIP -eq 1 ]; then
  printf "  Note that SIP is enabled : cannot change persistent Time Machine speed settings for next boot!\n\n"
 fi

 export DefaultSpeed=
 export IfDefaultSpeedSet=
 export CheckSIP=
 exit 0
 
fi

# Main process - no command line parameters
# If TM process is set to execute in High speed mode
if [ $(CheckValue d) -eq 0 ]; then
 echo "  Time Machine speed mode is configured to be defined as High [0] at boot time"
 printf "  and is current running as "
 echo -2
 CheckValue c 
 echo

 if [ $CheckSIP -eq 1 ]; then
  if [ ! CheckValueTXT c; ]; then
  #if [ "$CurrentSpeed" == "0" ]; then
   echo "  Press CTRL-C to cancel or wait to change to Standard [1] now"
  elif [ CheckValueTXT c; ]; then
  #elif [ "$CurrentSpeed" == "1" ]; then
   echo "  Press CTRL-C to cancel or wait to change to High [0] now"
  fi
 else
  if [ ! CheckValueTXT c; ]; then
  #if [ "$CurrentSpeed" == "0" ]; then
   echo "  Press CTRL-C to cancel or wait to change to Standard [1] now and at next boot time"
  elif [ CheckValue c n; ]; then
  #elif [ "$CurrentSpeed" == "1" ]; then
   echo "  Press CTRL-C to cancel or wait to change to High [0] now and at next boot time"
  fi
 fi
 printf "  "
 for i in {1..5}
 do
  sleep 1
  printf .
 done

 # Reverts TM process setting to Standard or High
 # Will present a prompt for root password prompt, as needed
 printf "\n   "
 sudo ls > /dev/null
 printf "\n   "
 if [ CheckValueTXT c; ]; then
 #if [ "$CurrentSpeed" == "0" ]; then
  sudo sysctl debug.lowpri_throttle_enabled=1
 elif [ CheckValueTXT c; ]; then
 #elif [ "$CurrentSpeed" == "1" ]; then
  sudo sysctl debug.lowpri_throttle_enabled=0
 fi

 # If boot time preferences file exists, backup it and then change it to Standard speed.
 if [ -f /Library/LaunchDaemons/nothrottle.plist ]; then

  # Running backup to the startup settings file
  sudo cp /Library/LaunchDaemons/nothrottle.plist "/tmp/Library_LaunchDaemons_nothrottle.plist-[`date`]"

  # Changing value into startup settings file
  sudo ex +%s/debug.lowpri_throttle_enabled.*=.*[0]/debug.lowpri_throttle_enabled=1/g -scwq /Library/LaunchDaemons/nothrottle.plist

 fi

# If TM process is set to execute in Standard or Custom speed
elif [ $(CheckValue d) -gt 0 ]; then
		#elif [ $DefaultSpeed -gt 0 ]; then

 # For Standard speed mode
 if [ $(CheckValue d) -eq 1 ]; then
 #if [ "$DefaultSpeed" == "1" ]; then 
  echo "  Time Machine speed mode is configured to be defined as Standard [1] at boot time"

 # For Custom speed mode
 else
  echo "  Time Machine speed mode is configured to be defined with a Custom value [$DefaultSpeed] at boot time"
 fi

 printf "  and is current running as "
 CheckValueTXT c
 echo

 if [ $CheckSIP -eq 1 ]; then
  if [ "$CurrentSpeed" == "0" ]; then
   echo "  Press CTRL-C to cancel or wait to change to Standard [1] now"
  elif [ "$CurrentSpeed" == "1" ]; then
   echo "  Press CTRL-C to cancel or wait to change to High [0] now"
  fi
 else
  if [ "$CurrentSpeed" == "0" ]; then
   echo "  Press CTRL-C to cancel or wait to change to Standard [1] now and at next boot time"
  elif [ "$CurrentSpeed" == "1" ]; then
   echo "  Press CTRL-C to cancel or wait to change to High [0] now and at next boot time"
  fi
 fi
 printf "   "
 for i in {1..5}
 do
  sleep 1
  printf .
 done

 # Sets TM process setting to High speed mode
 # Will present a promt for root password, as needed
 printf "\n   "
 sudo ls > /dev/null
 printf "\n   "
 if [ "$CurrentSpeed" == "0" ]; then
  sudo sysctl debug.lowpri_throttle_enabled=1
 elif [ "$CurrentSpeed" == "1" ]; then
  sudo sysctl debug.lowpri_throttle_enabled=0
 fi
 export CurrentSpeed=`sysctl debug.lowpri_throttle_enabled | cut -f 2 -d \: | cut -f 2 -d \  `
 if [ "$DefaultSpeed" != "$CurrentSpeed" ]; then 

  # If boot time preferences file exists, backup it and confirm that the DefaultSpeed setting exist
  if [ -f /Library/LaunchDaemons/nothrottle.plist ]; then
   sudo cp /Library/LaunchDaemons/nothrottle.plist "/tmp/Library_LaunchDaemons_nothrottle.plist-[`date`]"
   export IfDefaultSpeedSet=`grep -qc debug.lowpri_throttle_enabled /Library/LaunchDaemons/nothrottle.plist`
   sudo ex +%s/debug.lowpri_throttle_enabled.*=.*[1-99999]/debug.lowpri_throttle_enabled=0/g -scwq /Library/LaunchDaemons/nothrottle.plist

  # If boot time preferences file does NOT exist
  else
   export IfDefaultSpeedSet=0

   if [ "$CheckSIP" == "1" ]; then
    echo
    echo "   NOTE: As SIP is enabled, it won't let me manage Time Machine boot time preferences file"
    echo "         Changes were done in runtime only until you disable SIP and then run this tool again"
    echo
    echo "   SIP Disable routine :" 
    echo "      1) boot in Recovery mode;"
    echo "      2) open Terminal;"
    echo "      3) run \"csrutil disable\""
    echo "      4) run \"reboot\""
    echo "      5) Login in normal mode"
    echo "      6) open Terminal and run this script again"
    echo
   else

    # Creating boot time prefences file
    sudo echo "<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
<key>Label</key>
<string>nothrottle</string>
<key>ProgramArguments</key>
<array>
<string>/usr/sbin/sysctl</string>
<string>debug.lowpri_throttle_enabled=0</string>
</array>
<key>RunAtLoad</key>
<true/>
</dict>
</plist>" >> /System/Library/LaunchDaemons/nothrottle.plist
    # Append was selected to avoid loosing any other setting
   fi

  fi

 else
  echo "   No need to change boot time preferences file"
 fi

fi

# Clear temp vars
export DefaultSpeed=
export IfDefaultSpeedSet=
export CheckSIP=
echo

